/*
 *  TOPPERS/JSP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Just Standard Profile Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *
 *  TOPPERS/JSP for Blackfin
 *
 *  Copyright (C) 2004 by Suikan
 *  Copyright (C) 2004 by Ujinosuke
 *
 *  L쌠҂́Cȉ (1)`(4) ̏CFree Software Foundation 
 *  ɂČ\Ă GNU General Public License  Version 2 ɋL
 *  qĂ𖞂ꍇɌC{\tgEFAi{\tgEFA
 *  ς̂܂ށDȉjgpEEρEĔzziȉC
 *  pƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *      XR[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *      pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *      ҃}jAȂǁjɁCL̒쌠\C̗pщL
 *      ̖ۏ؋Kfڂ邱ƁD
 *  (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *      płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *      ƁD
 *    (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *        쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *        񍐂邱ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *      QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 * 
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *  TOPPERSvWFNǵC{\tgEFAɊւāC̓Kp\
 *  ܂߂āCȂۏ؂sȂD܂C{\tgEFA̗pɂ蒼
 *  ړI܂͊ԐړIɐȂ鑹QɊւĂC̐ӔC𕉂ȂD
 * 
 *  
 */

/*
 *	^[QbgVXeˑW[iADSP-BF533pj
 */

#include "jsp_kernel.h"
#include <sil.h>
#include <cdefBF53x.h>
#include <sys/exception.h>
#include <ccblkfn.h>
#include <sysreg.h>

#define SYSCFG_VALUE 0x32

/*
 *  ^[QbgVXeˑ̏
 */
void
sys_initialize()
{
	// BF531/2/3̃Am[}[΍ rev 0.1, 0.2p
	// AZũIvV -si-revision x.y w肷
	// __SILICON_REVISION__ }N錾B
#if ( __SILICON_REVISION__ == 0x01 ) || (__SILICON_REVISION__ == 0x02 )

	sysreg_write( reg_SYSCFG,  SYSCFG_VALUE ) ;
#endif
	/*
	 *  PLL̐ݒ
	 *
	 */
	/*
	 *  27MHz*22{=594MHzɐݒ肷(600MHz)
	 *  27MHz*28{=756MHzɐݒ肷(750MHz)
	 *  CSEL = 1; SSEL = 5 (600MHz)
	 *  CSEL = 1; SSEL = 6 (750MHz)
	 */
	*pSIC_IWR = IWR_ENABLE(0);				// PLL̂IWR
#if CSELVAL == 1 
	*pPLL_DIV = CCLK_DIV1 | SCLK_DIV(SSELVAL);
#elif CSELVAL == 2
	*pPLL_DIV = CCLK_DIV2 | SCLK_DIV(SSELVAL);
#elif CSELVAL == 4
	*pPLL_DIV = CCLK_DIV4 | SCLK_DIV(SSELVAL);
#elif CSELVAL == 8
	*pPLL_DIV = CCLK_DIV8 | SCLK_DIV(SSELVAL);
#else
#error Wrong CSELVAL. Must be one of 1,2,4,8.
#endif
	
	*pPLL_CTL = MSELVAL << 9;
		
	asm("cli r0; csync; idle; sti r0;": : :"r0");
	*pSIC_IWR = IWR_ENABLE_ALL;


}


unsigned int priority_mask[16]={
0x00000000,
0x00000000,
0x00000000,
0x00000000,
0x00000000,
0x00000000,
0x00000000,
0x0000007F,
0x00000180,
0x00001E00,
0x0000E000,
0x00070000,
0x00180000,
0x00E00000,
0x00000000,
0x00000000
};


/*
* SIC_IARx͂āACxgʂƂɊ蓖ĂĂ銄荞
* ̃rbg}bvBSIC_IARx̃tB[hl͗D揇-7Ȃ̂
* ̕␳B
*/
void make_priority_mask( void )
{
	unsigned int i, priority, device, iar;
	
	
	/*
 *  荞ݏʂƂISRrbg}bv̍쐬
 *  SIC_IARx̐ݒ͂̕Oɍς܂邱
 */
 
 	for ( i=0; i<16; i++ ){
 		priority_mask[i] = 0;
 	}
 
	device = 1;
	iar = *pSIC_IAR0;
	
	for ( i=0; i<8; i++ ){
		priority = iar & 0xf;
		iar >>= 4;
		priority_mask[priority + 7] |= device;
		device <<= 1;
	}
	
	iar = *pSIC_IAR1;
	
	for ( i=0; i<8; i++ ){
		priority = iar & 0xf;
		iar >>= 4;
		priority_mask[priority + 7] |= device;
		device <<= 1;
	}
	iar = *pSIC_IAR2;
	
	for ( i=0; i<8; i++ ){
		priority = iar & 0xf;
		iar >>= 4;
		priority_mask[priority + 7] |= device;
		device <<= 1;
	}
}


/*
 * 荞݂̋A֎~
 *
 */
ER ena_int( INTNO intno )
{
	unsigned int mask;
	
	if ( intno >= DEVICE_INTERRUPT_COUNT )
		return ( E_PAR );
	else {
		mask = 1 << intno;
		*pSIC_IMASK |= mask;
		return (0);
	}
}
ER dis_int( INTNO intno )
{
	unsigned int mask;

	if ( intno > INTNO_WDG )
		return ( E_PAR );
	else {
		mask = 1 << intno;
		mask = ~mask;
		*pSIC_IMASK &= mask;
		return (0);
	}
}

/*
 * 荞݃}XN̑
 *
 *
 */
ER chg_ims( IMS ims )
{
	*pSIC_IMASK = ims;
	return( 0 );
}

extern ER get_ims( IMS * p_ims )
{
	*p_ims = *pSIC_IMASK;
	return( 0 );;
}


/*
 *  荞݂foCXɊ蓖Ă
 */
void device_dispatcher( unsigned int priority )
{
	unsigned int candidates, count, device;
	
	candidates = priority_mask[priority] & *pSIC_ISR & *pSIC_IMASK;	// ݂̃vCIeBɑ銄݌肷
	asm ( "%0 = ones %1;" :"=l"(count) :"d"(candidates)  );
	
	if ( ! count )
	{
#ifdef USE_HW_ERROR
		if ( priority == ik_hardware_err)
			dev_vector[INHNO_HW_ERROR]();
		else 
#endif
			if ( priority == ik_timer)
			dev_vector[INHNO_TIMER]();
		else
			dev_vector[INHNO_RAISE]();		//@\tgEFA荞

	}
	else 
	{
		if ( candidates & 0x80000000 )
			device = 31;
		else
		{
			asm( "%0 = signbits %1;\n" : "=l"( device ) : "d"( candidates ) : "r2" );
			device = 30 - device;		// bit mask is converted to bit number
		}
		dev_vector[device]();
	}
}



/*
 *  ^[QbgVXȅI
 */
void
sys_exit()
{
	while(1)
		1;
}

/*
 *  ^[QbgVXe̕o
 */
void
sys_putc(char c)
{
}



